/* GGI initialisation, most code is Copyright (C) W.H.Scholten 1998
 */

#include <stdio.h> 
#include <ggi/libggi.h>

#include "dtypes.h"
#include "macsys.h"
#include "grdef.h"
#include "gr.h"
#include "palette.h"
#include "mem.h"
#include "key.h"


#include "debug.h"


int  MonitorRowBytes;			// rowbytes for current monitor

int  err;
int  full_width, full_height;
int  display_type, display_depth, bpp, Bpp;

//GGI specific:
ggi_visual_t		visual;
ggi_directbuffer_t		dbuf;	// GGI direct acces to screen memory
ggi_pixellinearbuffer	*plb;

bool libggi_init, visual_open, mode_switched;



ubyte Compatibility_mode = 0;	// compatibility mode using copybits?
/* used in game.c/macwin.c: What is copybits? get rid of it? */

int  GWorldWidth, GWorldHeight; //used in scrncpy.c/macwin.c


//called in 2d/gr.c
void set_win_size(int x, int y, int w, int h)
{
	GWorldWidth = w;
	GWorldHeight = h;


	//  Size the GameWindow.  We need to be sure that the left edge of the window falls on
	//  a multiple of 8 byte boundry for speed purposes on the direct screen copy.  The new width
	//  will always be some multiple of 16 to ensure that we have a total byte count per row of
	//  some multiple of eight bytes.

	//	if (((x / 8) * 8) != x)
	//		x -= (x % 8);
	//	MoveWindow(GameWindow, x, y, 1);
}

grs_canvas *mac_get_gworld_data(int w, int h)
{
	void *buffer;
	grs_canvas *new;

	int x=0; int y=0;

	buffer = ((byte *) plb->write) + (plb->stride * y)+x;

	new = (grs_canvas *)mymalloc( sizeof(grs_canvas) );

	new->cv_bitmap.bm_x = 0;
	new->cv_bitmap.bm_y = 0;
	new->cv_bitmap.bm_w = w;
	new->cv_bitmap.bm_h = h;
	new->cv_bitmap.bm_flags = 0;
	new->cv_bitmap.bm_type = BM_LINEAR;
//	new->cv_bitmap.bm_rowsize = (**pixmap).rowBytes & 0x3fff;
	new->cv_bitmap.bm_rowsize = plb->stride;

	new->cv_bitmap.bm_data = (ubyte *)buffer;

	new->cv_color = 0;
	new->cv_drawmode = 0;
	new->cv_font = NULL;
	new->cv_font_fg_color = 0;
	new->cv_font_bg_color = 0;
	return new;
}



#define GGI_DISPLAY 3

int macwin_init()
{
	int w,h;

//	key_close();
//	show_cursor();

//	hide_cursor();
//	key_init();

#if 1
	w = 640; h = 480;
#else
	w = 320; h = 200;
#endif

	full_width=w; full_height=h;


	if (ggiInit()) {
	    fprintf(stderr, "GGI: libggi error\n");
	    return -1;
	}
	libggi_init=True;;

//	visual = ggiOpen("display-KGI:/dev/graphic", NULL);
	visual = ggiOpen (NULL);
	if (visual==NULL) {
	    fprintf(stderr, "GGI: failed to create visual\n");
	    return -1;
	}
	visual_open=True;

	/* Open our DISPLAY */
	err=ggiSetGraphMode(visual, full_width, full_height, full_width, full_height, GT_8BIT);
	if (err) {
	    fprintf(stderr, "GGI: Can't set screen mode..\n");
	    return -1;
	}
	mode_switched=True;

	display_type=GGI_DISPLAY;
	display_depth=bpp;

	Bpp=(display_depth+7)/8;

	/* Direct display buffer */
	dbuf = NULL;
	if ( (err = ggiDBGetBuffer (visual, &dbuf)) ) {
	    fprintf(stderr, "GGI: couldn't get framebuffer access\n");
	    return -1;
	}
	if (ggiDBGetLayout (dbuf) != blPixelLinearBuffer) {
	    fprintf(stderr, "GGI: non linear framebuffer not supported\n");
	    return -1;
	}
	if ( !(plb = ggiDBGetPLB (dbuf)) ) {
	    fprintf(stderr, "GGI: GetPLB Failed\n");
	    return -1;
	}
	MonitorRowBytes = plb->stride;

#if 0
	if (page_flipping_on) {
	    screen_width = plb->stride;
	    ggiSetOrigin(disp, 0, 0);
	    visible_screen = 0;
	    offscreen_buffer = (byte *)plb->write + screen_width*Bpp*screen_height;
	} else {
	    offscreen_buffer = (byte *)malloc(screen_width*Bpp*screen_height);
	}
#endif

	return 0;	
}
